import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.serial.*; 
import processing.net.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class HTTPClient extends PApplet {

/**
 * HTTP Client. 
 * 
 * Starts a network client that connects to a server on port 80,
 * sends an HTTP 1.0 GET request, and prints the results. 
 *
 * Note that this code is not necessary for simple HTTP GET request:
 * Simply calling loadStrings("http://www.processing.org") would do
 * the same thing as (and more efficiently than) this example.
 * This example is for people who might want to do something more 
 * complicated later.
 */
 



Client c;
String data;
JSONObject json;
Serial myPort;

public void setup() {
  size(200, 200);
  background(50);

  myPort = new Serial(this, "COM4", 9600);
  fill(200);
  c = new Client(this, "127.0.0.1", 5200); // Connect to server on port 80
  c.write("GET / HTTP/1.0\r\n"); // Use the HTTP "GET" command to ask for a Web page
  c.write("\r\n");
}

public void draw() {
  
  if (c.available() > 0) { // If there's incoming data from the client...
    data = c.readString(); // ...then grab it and print it
    json = JSONObject.parse(data);
    JSONArray arr = json.getJSONObject("CpuInfo").getJSONArray("fTemp");
    println("---------------");
    
    myPort.write(arr.getInt(0));
    myPort.write(str(arr.getInt(0)) + " " + str(arr.getInt(1)) + " " + str(arr.getInt(2)) + " " + str(arr.getInt(3)) + " ");
    
    println(arr.getInt(0));
    println(arr.getInt(1));
    println(arr.getInt(2));
    println(arr.getInt(3));
    
    //println(data);
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "HTTPClient" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
