import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.serial.*; 
import processing.net.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class MicroViewCPUMonitor extends PApplet {

/**
 * MicroView CPU Monitor
 */




Client c;
String data;
JSONObject json;
Serial myPort;
int time;
int wait = 1000;
PFont f; 

public void setup() {
  size(120, 85);
  f = createFont("Arial", 16, true);
  background(50);
  time = millis();

  myPort = new Serial(this, "COM4", 9600);
  fill(200);
  reconnect();
}

public void reconnect()
{
  c = null;
  c = new Client(this, "127.0.0.1", 5200); // Connect to server on port 80
  c.write("GET / HTTP/1.0\r\n"); // Use the HTTP "GET" command to ask for a Web page
  c.write("\r\n");
}

public void draw() {

  if (c!=null && !c.active()) {
    println("CLIENT GOT DISCONNECTED");
    reconnect();
  }
  if (millis() - time >= wait) {
    time = millis();
  }

  if (c!=null && c.available() > 0) { // If there's incoming data from the client...
    data = c.readStringUntil(10); // ...then grab it and print it
    if (data!=null)
    {
      json = JSONObject.parse(data);
      JSONArray arr = json.getJSONObject("CpuInfo").getJSONArray("uiLoad");
      JSONArray arrtmp = json.getJSONObject("CpuInfo").getJSONArray("fTemp");
      int temp = (int)(arrtmp.getInt(0) + arrtmp.getInt(1) + arrtmp.getInt(2) + arrtmp.getInt(3)) / 4;
      println("---------------");
      String strToSend = "S" + str(arr.getInt(0)) + " " + str(arr.getInt(1)) + " " + str(arr.getInt(2)) + " " + str(arr.getInt(3)) + " " + str(temp) + " ";
      myPort.write(strToSend);
      background(255);
      textFont(f, 16);
      fill(0); 
      text("CPU1: " + str(arr.getInt(0)), 0, 16);
      text("CPU2: " + str(arr.getInt(1)), 0, 32);
      text("CPU3: " + str(arr.getInt(2)), 0, 48);
      text("CPU4: " + str(arr.getInt(3)), 0, 64);
      text("TEMP: " + str(temp), 0, 80);
      println(strToSend);
    } else
    {
      //println("Data null"); // for the debug purposes
    }
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "MicroViewCPUMonitor" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
